=== debian/changelog ===
polarssl (1.3.9-2.1+deb8u3) jessie-security; urgency=medium

  * Fix CVE-2017-18187:
    Unsafe bounds check in ssl_parse_client_psk_identity().
  * Fix CVE-2018-0487:
    Buffer overflow when verifying RSASSA-PSS signatures. (Closes: #890288)
  * Fix CVE-2018-0488:
    Buffer overflow when truncated HMAC is enabled. (Closes: #890287)

 -- James Cowgill <jcowgill@debian.org>  Tue, 20 Mar 2018 17:59:03 +0000

polarssl (1.3.9-2.1+deb8u2) jessie; urgency=high

  * Fix CVE-2017-2784: Freeing of memory allocated on stack when
    validating a public key with a secp224k1 curve. (Closes: #857561)

 -- James Cowgill <jcowgill@debian.org>  Tue, 09 May 2017 09:42:21 +0100

polarssl (1.3.9-2.1+deb8u1) jessie-security; urgency=high

  * Non-maintainer upload.
  * Backport patches for CVE-2015-5291 and CVE-2015-8036
    (Closes: #801413)
  * Add simple smoke test

 -- Guido Günther <agx@sigxcpu.org>  Fri, 05 Feb 2016 13:41:23 +0100

polarssl (1.3.9-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Add CVE-2015-1182.patch patch.
    CVE-2015-1182: Denial of service and possible remote code execution
    using crafted certificates. (Closes: #775776)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 21 Jan 2015 22:09:05 +0100

polarssl (1.3.9-2) unstable; urgency=medium

  * Disabled POLARSSL_SSL_PROTO_SSL3 at compile time to prevent potential
    attacks, TLS considered standard for clients now, and consistency w/
    OpenSSL in Debian

 -- Roland Stigge <stigge@antcom.de>  Fri, 07 Nov 2014 10:28:34 +0100

polarssl (1.3.9-1) unstable; urgency=medium

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Wed, 05 Nov 2014 18:34:31 +0100

polarssl (1.3.8-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Adjust package description, thanks to Paul Bakker
    (upstream)
  * Removed CVE-2014-4911.patch (integrated upstream)

 -- Roland Stigge <stigge@antcom.de>  Sun, 31 Aug 2014 14:13:55 +0200
