=== debian/control ===
Source: polarssl
Section: libs
Priority: optional
Maintainer: Roland Stigge <stigge@antcom.de>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9)
Homepage: http://polarssl.org

Package: libpolarssl-dev
Architecture: any
Section: libdevel
Depends: libc6-dev, ${misc:Depends}, libpolarssl7 (= ${binary:Version})
Description: lightweight crypto and SSL/TLS library
 PolarSSL is a lean open source crypto library for providing SSL and TLS
 support in your programs. It offers an intuitive API and documented header
 files, so you can actually understand what the code does. It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5 
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - SSL v3 and TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the static library and the header files.

Package: libpolarssl-runtime
Architecture: any
Section: libdevel
Depends: libc6-dev, ${misc:Depends}
Description: lightweight crypto and SSL/TLS library
 PolarSSL is a lean open source crypto library for providing SSL and TLS
 support in your programs. It offers an intuitive API and documented header
 files, so you can actually understand what the code does. It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5 
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - SSL v3 and TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the runtime executables.

Package: libpolarssl7
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight crypto and SSL/TLS library
 PolarSSL is a lean open source crypto library for providing SSL and TLS
 support in your programs. It offers an intuitive API and documented header
 files, so you can actually understand what the code does. It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5 
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - SSL v3 and TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the shared library.
